#NoTrayIcon
#AutoIt3Wrapper_icon=nrbackup.ico

#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <GUIListBox.au3>
#Include <Array.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <EditConstants.au3>
#Include <File.au3>
#include <Constants.au3>
#Include <GuiListView.au3>


$nom="NRbackup 1.2a - Simple Backup - CopyLeft Nicolas Ricquemaque 2009-11 [CeCILL2]"

$ini=".\nrbackup.ini"
$Apropos= @crlf&"NrBackup est un utilitaire ultra-simple de sauvegarde des donnes d'un" & @CRLF
$Apropos&="disque  un autre. Il suffit de lui donner une liste de dossier "& @CRLF
$Apropos&="sauvegarder, et un lecteur destination. Ces paramtres sont conservs"& @CRLF
$Apropos&="dans un fichier nrbackup.ini. Il permet d'jecter automatiquement sur"& @CRLF
$Apropos&="demande le disque destination et d'teindre l'ordinateur une fois termin."& @CRLF& @CRLF
$Apropos&=" - Seuls les fichiers non prsents ou modifis sont copis"& @CRLF
$Apropos&=" - Les fichiers qui ont disparus sont supprims"& @CRLF& @CRLF
$Apropos&="Copyleft Nicolas Ricquemaque 2009-11 - Sous Licence libre CeCill v2."

$dossiers=IniRead ( $ini, "Config", "Dossiers", "" )
$cible=IniRead ( $ini, "Config", "Cible", "" )

$win=GUICreate($nom, 400, 250)
$tab=GuiCtrlCreateTab(5, 5, 390, 240)
; ------------------------------------------------------------------------------- 
$backup=GuiCtrlCreateTabItem("Backup")
GuiCtrlCreateLabel("Dossiers  sauvegarder :", 20, 40,200,20)
$liste = GUICtrlCreateList("", 20, 60, 260, 130)
GUICtrlSetData (-1, $dossiers)
GuiCtrlCreateLabel("Dossier cible :", 20, 195,80,20)
$ejection=GUICtrlCreateCheckbox ( "Ejecter aprs", 200, 192 )
If IniRead ( $ini, "Config", "Ejection", "non" )="oui" Then GUICtrlSetState(-1,$GUI_CHECKED)
$cible=GuiCtrlCreateInput($cible, 20, 215, 260)
$backup=GuiCtrlCreateButton(" Backup ", 310, 50)
$eteindre=GUICtrlCreateCheckbox ( "Eteindre aprs", 295, 90 )
If IniRead ( $ini, "Config", "Extinction", "non" )="oui" Then GUICtrlSetState(-1,$GUI_CHECKED)
$add=GuiCtrlCreateButton(" + ", 300, 125, 30)
$supp=GuiCtrlCreateButton(" - ", 340, 125, 30)
GUICtrlSetState(-1,$GUI_DISABLE)
$logs=GUICtrlCreateCheckbox ( "Fichier de logs", 295, 165 )
If IniRead ( $ini, "Config", "Logs", "non" )="oui" Then GUICtrlSetState(-1,$GUI_CHECKED)
$ciblesel=GuiCtrlCreateButton(" ... ", 300, 210, 30)
; -------------------------------------------------------------------------------
GuiCtrlCreateTabItem("Exclusions")
GuiCtrlCreateLabel("Fichiers  exclure du backup :", 20, 40,200,20)
$exclusions = GUICtrlCreateList("", 20, 60, 260, 130)
$add_ex=GuiCtrlCreateButton(" + ", 300, 60, 30)
$sup_ex=GuiCtrlCreateButton(" - ", 340, 60, 30)
Global $exclu_lst[1]
$i=0
Do
	$exclu=IniRead ( $ini, "Exclusions", "Exclusion"&$i ,"")
	If $exclu<>"" Then
		GUICtrlSetData($exclusions,$exclu)
		$exclu_lst[Ubound($exclu_lst)-1]=$exclu
		ReDim $exclu_lst[Ubound($exclu_lst)+1]
		$i+=1
	EndIf
Until $exclu=""

; -------------------------------------------------------------------------------
GuiCtrlCreateTabItem("    ?")
GuiCtrlCreateLabel($Apropos, 20, 40,360,160)
$licence=GuiCtrlCreateButton("Licence", 30, 210,70)
$sitenrbackup=GuiCtrlCreateButton("Site", 120, 210,70)
$codesrc=GuiCtrlCreateButton("Code Source", 300, 210,70)
; -------------------------------------------------------------------------------
GuiCtrlCreateTabItem("")

GUICtrlSetState($backup,$GUI_SHOW)
GUISetState()

SetupEject()

If GUICtrlRead($logs)=$GUI_CHECKED Then FileDelete ("nrbackup.log")

While 1
	$msg = GUIGetMsg()	
	If $msg = $GUI_EVENT_CLOSE Then ExitLoop	
	
	If _GUICtrlListBox_GetCurSel($liste)>=0 Then 
		If BitAND(GUICtrlGetState($supp),$GUI_DISABLE) Then GUICtrlSetState($supp,$GUI_ENABLE)
	ElseIf BitAND(GUICtrlGetState($supp),$GUI_ENABLE) Then 
		GUICtrlSetState($supp,$GUI_DISABLE) 
	EndIf
	
	If FileExists(GUICtrlRead ($cible))  AND _GUICtrlListBox_GetCount($liste)>0 Then 
		If BitAND(GUICtrlGetState($backup),$GUI_DISABLE) Then GUICtrlSetState($backup,$GUI_ENABLE)
	ElseIf BitAND(GUICtrlGetState($backup),$GUI_ENABLE) Then 
		GUICtrlSetState($backup,$GUI_DISABLE) 
	EndIf
	
	If $msg = $add Then
		$new=FileSelectFolder ( "Dossier  ajouter", "")
		If ($new<>"") Then
			GUICtrlSetData($liste, $new)		
		EndIf
	EndIf
	
	If $msg=$add_ex Then
		$exclu=InputBox ( "Fichiers  exclure", 'Fichiers  exclure (ex: *.bak)')
		If $exclu="" Then ContinueLoop		
		GUICtrlSetData($exclusions,$exclu)
		$exclu_lst[Ubound($exclu_lst)-1]=$exclu
		ReDim $exclu_lst[Ubound($exclu_lst)+1]
	EndIf
	
	If $msg=$sup_ex Then
		$tmp=GUICtrlRead($exclusions)
		if ($tmp<>"") Then	
			$index = _ArraySearch($exclu_lst, $tmp)
			If $index>-1 Then _ArrayDelete($exclu_lst,$index)
			$index =_GUICtrlListBox_GetCurSel ($exclusions)
			_GUICtrlListBox_DeleteString ($exclusions, $index)
		EndIf
	EndIf
	
	If $msg = $supp Then _GUICtrlListBox_DeleteString($liste, _GUICtrlListBox_GetCurSel($liste))
	
	If $msg = $ciblesel Then
		$new=FileSelectFolder ( "Dossier cible", "")
		If ($new<>"") Then
			if StringRight($new,1)="\" Then $new=StringTrimRight($new,1)
			GUICtrlSetData($cible, $new)		
		EndIf
	EndIf
	
	If $msg = $backup Then Backup()
	
	If $msg = $licence Then Licence()
	If $msg = $sitenrbackup Then ShellExecute("http://opensource.grisambre.net/nrbackup")
	If $msg = $codesrc Then
		$dest=FileSaveDialog ( "Enregistrement du code source", @ScriptDir, "Archive compresse (*.zip)", 18 , "nrbackup-src.zip")
		If ($dest) Then FileInstall("nrbackup-src.zip",$dest,1)
	EndIf
		
WEnd

WriteIni()
GUIDelete()
Exit


Func WriteIni()
	FileDelete( $ini )
	IniWrite ( $ini, "Config", "Cible", GUICtrlRead ( $cible) )
	$l=""
	for $i = 1 to _GUICtrlListBox_GetCount($liste)
		$l&=_GUICtrlListBox_GetText($liste, $i-1)&"|"
	next
	IniWrite ( $ini, "Config", "Dossiers", $l )
	If GUICtrlRead($ejection)=$GUI_CHECKED Then
		IniWrite ( $ini, "Config", "Ejection", "Oui" )
	Else
		IniWrite ( $ini, "Config", "Ejection", "Non" )
	EndIf
	If GUICtrlRead($eteindre)=$GUI_CHECKED Then
		IniWrite ( $ini, "Config", "Extinction", "Oui" )
	Else
		IniWrite ( $ini, "Config", "Extinction", "Non" )
	EndIf
	If GUICtrlRead($logs)=$GUI_CHECKED Then
		IniWrite ( $ini, "Config", "Logs", "Oui" )
	Else
		IniWrite ( $ini, "Config", "Logs", "Non" )
	EndIf
	For $i=0 to Ubound($exclu_lst)-2
		If $exclu_lst[$i]<>"" Then IniWrite ( $ini, "Exclusions", "Exclusion"&$i, $exclu_lst[$i] )
	Next
EndFunc


Func backup ()	
	global $win1=GuiCreate("Backup...", 500, 370,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
	GuiCtrlCreateLabel("Dossier : ", 20, 20, 80,default,$SS_RIGHT)
	global $_dossier=GuiCtrlCreateLabel("", 120,20,350,30)
	GuiCtrlCreateLabel("Parcourus : ", 20, 45, 80,default,$SS_RIGHT)
	global $_nb=GuiCtrlCreateLabel("0", 120, 45,60)
	GuiCtrlCreateLabel("Copis : ", 20, 70, 80,default,$SS_RIGHT)
	$termine=GuiCtrlCreateLabel("", 230, 70,60,30)
	global $_copies=GuiCtrlCreateLabel("0", 120, 70,60)
	GuiCtrlCreateLabel("Mis  jour : ", 20, 95, 80,default,$SS_RIGHT)
	global $_ajour=GuiCtrlCreateLabel("0", 120, 95,60)
	GuiCtrlCreateLabel("Supprims : ", 20, 120, 80,default,$SS_RIGHT)
	global $_supprimes=GuiCtrlCreateLabel("0", 120, 120, 60)
	GuiCtrlCreateLabel("Exclus : ", 20, 145, 80,default,$SS_RIGHT)
	global $_exclus=GuiCtrlCreateLabel("0", 120, 145, 60)
	global $break=GUICtrlCreateButton ( " Interrompre ", 350, 80, 80)
	
	global $listview = GUICtrlCreateListView("Action|Fichier|Etat", 20, 180, 460, 150)	
	global $nblistview=0
	_GUICtrlListView_SetColumnWidth($listview, 0, 90)
	_GUICtrlListView_SetColumnWidth($listview, 1, 300)
	_GUICtrlListView_SetColumnWidth($listview, 2, 50)
	GuiSetState(@SW_SHOW,$win1)

	global $nb=0
	global $copies=0
	global $ajour=0
	global $supprimes=0
	global $exclus=0
	global $dest=GUICtrlRead ($cible)
	
	; Fabrication de la regexp des exlusions
	global $excluRegExp=""
	If Ubound($exclu_lst)>1 Then
		For $i=0 to Ubound($exclu_lst)-2 
			if StringLen($excluRegExp)>0 Then $excluRegExp = $excluRegExp & "|"
			$excluRegExp = $excluRegExp & Wildcards2Regexp($exclu_lst[$i])
		Next
	EndIf
	
	for $i = 1 to _GUICtrlListBox_GetCount($liste)
		global $base=_GUICtrlListBox_GetText($liste, $i-1)
		if (recur(_GUICtrlListBox_GetText($liste, $i-1))=-1) then return -1
	next
	
	GUICtrlSetData($termine,"Termin !")
	WriteIni()
	If GUICtrlRead($eteindre)==$GUI_CHECKED Then Arret()
	If GUICtrlRead($ejection)=$GUI_CHECKED Then _EjectDrive(StringLeft($dest,1))

	GUICtrlSetData($break," Quitter ")

	While 1
		$msg=GuiGetMsg()
		If $msg=$break Then
			GUIDelete($win1)
			return 0
		EndIf
	Wend
EndFunc


Func recur ($dossier)

	If GuiGetMsg()=$break Then
		GUIDelete($win1)
		return -1
	EndIf
	
	$d=$dossier
	If StringLen($dossier)>50 Then $d="(...)"&StringMid($dossier,StringLen($dossier)-50)
	GUICtrlSetData($_dossier,$d)
	
	If CheckFile($dest&"\"&ShortPath($base,$dossier))<>1 Then DirCreate ($dest&"\"&ShortPath($base,$dossier))
	$search = FileFindFirstFile($dossier&"\*.*")
	If $search = -1 Then return

	While 1
		If GuiGetMsg()=$break Then
			GUIDelete($win1)
			FileClose($search)
			return -1
		EndIf
		$file = FileFindNextFile($search) 
		If @error Then ExitLoop
		If StringLeft($file,1)<>"." AND CheckFile($dossier&"\"&$file )=1 Then 
			if recur($dossier&"\"&$file)=-1 then return -1
		Else
			$nb+=1
			GUICtrlSetData($_nb,$nb)
			If StringRegExp($file,$excluRegExp,0) Then
				If GUICtrlRead($logs)=$GUI_CHECKED Then FileWriteLine ( "nrbackup.log", @MDAY&"/"&@MON&"/"&@YEAR&" "&@HOUR&":"&@MIN&":"&@SEC&" Exclu " & $dest&"\"&ShortPath($base,$dossier)&"\"&$file)
				GUICtrlCreateListViewItem("Exclu|"&$file&"|Ok", $listview)
				_GUICtrlListView_EnsureVisible($listview, $nblistview)
				$exclus+=1
				$nblistview+=1
				GUICtrlSetData($_exclus,$exclus)
			ElseIf (CheckFile($dest&"\"&ShortPath($base,$dossier)&"\"&$file)<>2) Then				
				If GUICtrlRead($logs)=$GUI_CHECKED Then FileWriteLine ( "nrbackup.log", @MDAY&"/"&@MON&"/"&@YEAR&" "&@HOUR&":"&@MIN&":"&@SEC&" Copie " & $dossier&"\"&$file &" vers "&$dest&"\"&ShortPath($base,$dossier))
				GUICtrlCreateListViewItem("Copie|"&$file&"|0 %", $listview)				
				_GUICtrlListView_EnsureVisible($listview, $nblistview)
				If Not MyCopy($dossier&"\"&$file, $dest&"\"&ShortPath($base,$dossier)) Then
					GUIDelete($win1)
					FileClose($search)
					return -1
				EndIf
				$nblistview+=1
				$copies+=1
				GUICtrlSetData($_copies,$copies)			
			ElseIf (FileGetSize($dossier&"\"&$file)<>FileGetSize($dest&"\"&ShortPath($base,$dossier)&"\"&$file) OR Abs(FileGetTime($dossier&"\"&$file,0,1)-FileGetTime($dest&"\"&ShortPath($base,$dossier)&"\"&$file,0,1))>60) Then				
				$cause=""
				If (FileGetSize($dossier&"\"&$file)<>FileGetSize($dest&"\"&ShortPath($base,$dossier)&"\"&$file)) Then $cause&=" [Taille]"
				If (Abs(FileGetTime($dossier&"\"&$file,0,1)-FileGetTime($dest&"\"&ShortPath($base,$dossier)&"\"&$file,0,1))>1) Then $cause&=" [Date]"
				If GUICtrlRead($logs)=$GUI_CHECKED Then FileWriteLine ( "nrbackup.log", @MDAY&"/"&@MON&"/"&@YEAR&" "&@HOUR&":"&@MIN&":"&@SEC&" Mise  jour " & $dossier & "\" & $file & " vers "&$dest&"\"&ShortPath($base,$dossier)&$cause)
				GUICtrlCreateListViewItem("Mise  jour|"&$file&"|0 %", $listview)				
				_GUICtrlListView_EnsureVisible($listview, $nblistview)
				If Not MyCopy($dossier&"\"&$file, $dest&"\"&ShortPath($base,$dossier)) Then
					GUIDelete($win1)
					FileClose($search)
					return -1
				EndIf
				$nblistview+=1
				$ajour+=1
				GUICtrlSetData($_ajour,$ajour)	
			EndIf
		EndIf	
	WEnd
	FileClose($search)

	$search = FileFindFirstFile($dest&"\"&ShortPath($base,$dossier)&"\*.*")
	If $search = -1 Then return
	While 1
		$file = FileFindNextFile($search) 
		If @error Then ExitLoop
		If StringLeft($file,1)="." AND CheckFile($dest&"\"&ShortPath($base,$dossier)&"\"&$file )=1 Then ContinueLoop
		If StringRegExp($file,$excluRegExp,0) Then
			If GUICtrlRead($logs)=$GUI_CHECKED Then FileWriteLine ( "nrbackup.log", @MDAY&"/"&@MON&"/"&@YEAR&" "&@HOUR&":"&@MIN&":"&@SEC&" Exclu " & $dest&"\"&ShortPath($base,$dossier)&"\"&$file)
			GUICtrlCreateListViewItem("Exclu|"&$file&"|Ok", $listview)
			_GUICtrlListView_EnsureVisible($listview, $nblistview)
			$exclus+=1
			$nblistview+=1
			GUICtrlSetData($_exclus,$exclus)
		ElseIf CheckFile($dest&"\"&ShortPath($base,$dossier)&"\"&$file )=2 AND CheckFile($dossier&"\"&$file )=0 Then 
			$supprimes+=1			
			If GUICtrlRead($logs)=$GUI_CHECKED Then FileWriteLine ( "nrbackup.log", @MDAY&"/"&@MON&"/"&@YEAR&" "&@HOUR&":"&@MIN&":"&@SEC&" Suppression " & $dest&"\"&ShortPath($base,$dossier)&"\"&$file)
			GUICtrlCreateListViewItem("Suppression|"&$file&"|0 %", $listview)			
			_GUICtrlListView_EnsureVisible($listview, $nblistview)			
			FileDelete ($dest&"\"&ShortPath($base,$dossier)&"\"&$file)	
			_GUICtrlListView_SetItemText($listview, $nblistview, "Ok",2)
			$nblistview+=1		
			GUICtrlSetData($_supprimes,$supprimes)
		ElseIf CheckFile($dest&"\"&ShortPath($base,$dossier)&"\"&$file )=1 AND CheckFile($dossier&"\"&$file )=0 Then 
			$supprimes+=1			
			If GUICtrlRead($logs)=$GUI_CHECKED Then FileWriteLine ( "nrbackup.log", @MDAY&"/"&@MON&"/"&@YEAR&" "&@HOUR&":"&@MIN&":"&@SEC&" Supression " & $dest&"\"&ShortPath($base,$dossier)&"\"&$file)
			GUICtrlCreateListViewItem("Supression|"&$file&"|0 %", $listview)			
			_GUICtrlListView_EnsureVisible($listview, $nblistview)			
			DirRemove ($dest&"\"&ShortPath($base,$dossier)&"\"&$file,true)		
			_GUICtrlListView_SetItemText($listview, $nblistview, "Ok",2)	
			$nblistview+=1			
			GUICtrlSetData($_supprimes,$supprimes)
		EndIf
	Wend
	FileClose($search)
EndFunc



Func MyCopy($src,$dst)
	$taille=FileGetSize($src)
	$ffpid=Run(@ComSpec & " /c " & 'copy /Y "'&$src&'" "'&$dst&'"', "", @SW_HIDE)	
	While ProcessExists($ffpid)		
		$stats=ProcessGetStats($ffpid,1)
		$p=$stats[3]/$taille*100
		if $p >= 100 Then $p="Ok"
		_GUICtrlListView_SetItemText($listview, $nblistview, Round($p) & " %",2)
		$temps=TimerInit ()
		while TimerDiff($temps)<1000 And ProcessExists($ffpid)
			If GuiGetMsg()=$break Then
				ProcessClose($ffpid)
				_GUICtrlListView_SetItemText($listview, $nblistview, "stop", 2)
				return false
			EndIf
		Wend
	Wend
	_GUICtrlListView_SetItemText($listview, $nblistview, "Ok",2)
	return true
EndFunc




; ---------------------- Bloc de fonctions diverses ----------------------------------

Func Wildcards2Regexp ($wildcards)
	return "^(?i:" & StringReplace(StringReplace(StringReplace($wildcards,".","[.]"),"?","."),"*",".*") & ")$"
EndFunc


Func Licence()
	If FileGetSize(@ScriptDir &"\Licence_CeCILL_V2-fr.txt")<>21979 Then FileInstall("Licence_CeCILL_V2-fr.txt", @ScriptDir &"\Licence_CeCILL_V2-fr.txt",1)
	$win0=GuiCreate("Contrat de Licence Wbidou", 500, 420,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
	GUISetFont ("8" , 400)
	GuiCtrlCreateLabel($Apropos, 20, 10,460,150)
	GUICtrlCreateEdit(FileRead(@ScriptDir &"\Licence_CeCILL_V2-fr.txt"),10,170,480,170,BitOr($ES_MULTILINE,$ES_READONLY,$WS_VSCROLL))
	GUISetFont ("9" , 400)
	$ok=GUICtrlCreateButton ( " OK ", 60, 355,80)
	$cecill=GUICtrlCreateButton ( " Cecill ? ", 360, 355,80)
	GUICtrlSetTip(-1,"http://www.cecill.info")
	GuiSetState(@SW_SHOW,$win0)
	While 1
		$msg=GuiGetMsg()
		If $msg=$cecill Then ShellExecute("http://www.cecill.info")
		If $msg=$ok Then
			GUIDelete($win0)
			return 1
		EndIf
	Wend
EndFunc


Func CheckFile($file) ; renvoie 0=existe pas, 1=dossier 2=fichier
	If Not FileExists($file) Then return 0
	If StringInStr($file,"*") Then return 0
	If StringInStr($file,"?") Then return 0
	$attrib=FileGetAttrib($file)
	If @error Then return 0
	If StringInStr($attrib, "D") Then return 1
	return 2
EndFunc


Func ShortPath ($base,$fullpath)
	return (StringTrimLeft ( $fullpath, StringInStr($base,"\",2,-1)))
EndFunc


Func Arret()
	If MsgBox(0,"Arrt ?","L'ordinateur va s'arrter dans 30s. Vous pouvez encore l'empcher en cliquant sur OK !",30)==1 Then return
	ShutDown(9)
	exit
EndFunc


Func SetupEject()
	#include <WinAPI.au3>
	; http://www.autoitscript.com/forum/index.php?showtopic=83470
	; Constants
	Global Const $FS_READ = 0x1
	Global Const $FS_WRITE = 0x2
	Global Const $O_EXISTS = 3
	;Global Const $INVALID_HANDLE_VALUE = Ptr(0xFFFFFFFF); invalid ptr value
	Global Const $IOCTL_STORAGE_GET_DEVICE_NUMBER = 0x2D1080
	Global Const $DRIVE_REMOVABLE = 2
	Global Const $DRIVE_FIXED = 3
	Global Const $DRIVE_CDROM = 5
	Global Const $DIGCF_PRESENT = 0x2
	Global Const $DIGCF_DEVICEINTERFACE = 0x10
	Global Const $NULL = Chr(0)
	Global Const $CR_SUCCESS = 0x0
	Global Const $DN_REMOVABLE = 0x4000
	Global Const $CM_REMOVE_NO_RESTART = 0x2
	Global Const $CR_ACCESS_DENIED = 0x33
	Global Const $PNP_VetoTypeUnknown = 0         ; Name is unspecified
	Global Const $PNP_VetoLegacyDevice = 1        ; Name is an Instance Path
	Global Const $PNP_VetoPendingClose = 2        ; Name is an Instance Path
	Global Const $PNP_VetoWindowsApp = 3        ; Name is a Module
	Global Const $PNP_VetoWindowsService = 4    ; Name is a Service
	Global Const $PNP_VetoOutstandingOpen = 5    ; Name is an Instance Path
	Global Const $PNP_VetoDevice = 6            ; Name is an Instance Path
	Global Const $PNP_VetoDriver = 7            ; Name is a Driver Service Name
	Global Const $PNP_VetoIllegalDeviceRequest = 8; Name is an Instance Path
	Global Const $PNP_VetoInsufficientPower = 9    ; Name is unspecified
	Global Const $PNP_VetoNonDisableable = 10    ; Name is an Instance Path
	Global Const $PNP_VetoLegacyDriver = 11        ; Name is a Service
	Global Const $PNP_VetoInsufficientRights = 12; Name is unspecified

	; Structures
	Global Const $STORAGE_DEVICE_NUMBER = "ulong DeviceType;ulong DeviceNumber;ulong PartitionNumber"
	Global Const $SP_DEV_BUF = "byte[1024]"
	Global Const $SP_DEVICE_INTERFACE_DETAIL_DATA = "dword cbSize;char DevicePath[1020]"; created at SP_DEV_BUF ptr
	Global Const $SP_DEVICE_INTERFACE_DATA = "dword cbSize;byte InterfaceClassGuid[16];dword Flags;ptr Reserved"; GUID struct = 16 bytes
	Global Const $SP_DEVINFO_DATA = "dword cbSize;byte ClassGuid[16];dword DevInst;ptr Reserved"
EndFunc


Func _EjectDrive($drive)
; "X:\"    -> for GetDriveType
    $szRootPath = $drive & ":\"
; "X:"     -> for QueryDosDevice
    $szDevicePath = $drive & ":"
; "\\.\X:" -> to open the volume
    $szVolumeAccessPath = "\\.\" & $drive & ":"

    $DeviceNumber = -1

    $hVolume = DllCall("kernel32.dll", "ptr", "CreateFile", "str", $szVolumeAccessPath, "dword", 0, _
                        "dword", BitOR($FS_READ, $FS_WRITE), "ptr", $NULL, "dword", $O_EXISTS, _
                        "dword", 0, "ptr", $NULL)
    $hVolume = $hVolume[0]
    If $hVolume == $INVALID_HANDLE_VALUE Then Return 1

    $sdn = DllStructCreate($STORAGE_DEVICE_NUMBER)
    $res = DllCall("kernel32.dll", "int", "DeviceIoControl", "ptr", $hVolume,"dword", $IOCTL_STORAGE_GET_DEVICE_NUMBER, _
                    "ptr", $NULL, "dword", 0, "ptr", DllStructGetPtr($sdn), "dword", DllStructGetSize($sdn), _
                    "dword*", "", "ptr", $NULL)
    If $res[0] Then $DeviceNumber = DllStructGetData($sdn, "DeviceNumber")
    
    $res = DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hVolume)
    If Not $res[0] Then Return 1

    If $DeviceNumber == -1 Then Return 1

    $DriveType = DllCall("kernel32.dll", "uint", "GetDriveType", "str", $szRootPath)
    $DriveType = $DriveType[0]

; get the dos device name (like \device\floppy0)
; to decide if it's a floppy or not
    $res = DllCall("kernel32.dll", "dword", "QueryDosDevice", "str", $szDevicePath, "str", "", "dword", 260)
    If Not $res[0] Then Return 1
    $szDosDeviceName = $res[2]

    $DevInst = _GetDrivesDevInstByDeviceNumber($DeviceNumber, $DriveType, $szDosDeviceName)
    If $DevInst == 0 Then Return 1
    
    Return _DevInstEject($DevInst)
EndFunc

Func _GetDrivesDevInstByDeviceNumber($DeviceNumber, $DriveType, $szDosDeviceName)
	; GUIDs
	; GUID_DEVINTERFACE_DISK =         0x53f56307L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b
	; GUID_DEVINTERFACE_CDROM =     0x53f56308L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b
	; GUID_DEVINTERFACE_FLOPPY =     0x53f56311L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b
	$guidDisk = DllStructCreate($tagGUID)
	DllStructSetData($guidDisk, "Data1", 0x53f56307)
	DllStructSetData($guidDisk, "Data2", 0xb6bf)
	DllStructSetData($guidDisk, "Data3", 0x11d0)
	DllStructSetData($guidDisk, "Data4", Binary("0x94f200a0c91efb8b"))
	$guidCDROM = DllStructCreate($tagGUID)
	DllStructSetData($guidCDROM, "Data1", 0x53f56308)
	DllStructSetData($guidCDROM, "Data2", 0xb6bf)
	DllStructSetData($guidCDROM, "Data3", 0x11d0)
	DllStructSetData($guidCDROM, "Data4", Binary("0x94f200a0c91efb8b"))
	$guidFloppy = DllStructCreate($tagGUID)
	DllStructSetData($guidFloppy, "Data1", 0x53f56311)
	DllStructSetData($guidFloppy, "Data2", 0xb6bf)
	DllStructSetData($guidFloppy, "Data3", 0x11d0)
	DllStructSetData($guidFloppy, "Data4", Binary("0x94f200a0c91efb8b"))
	
    $IsFloppy = (StringInStr($szDosDeviceName, "\floppy") <> 0)
    
    Local $GUID
    Switch $DriveType
        Case $DRIVE_REMOVABLE
            If $IsFloppy Then
                $GUID = DllStructGetPtr($guidFloppy)
            Else
                $GUID = DllStructGetPtr($guidDisk)
            EndIf
        Case $DRIVE_FIXED
            $GUID = DllStructGetPtr($guidDisk)
        Case $DRIVE_CDROM
            $GUID = DllStructGetPtr($guidCDROM)
        Case Default
            Return 0
    EndSwitch
    
; Get device interface info set handle
  ; for all devices attached to system
    $hDevInfo = DllCall("setupapi.dll", "ptr", "SetupDiGetClassDevs", "ptr", $GUID, "ptr", $NULL, "hwnd", $NULL, _
                        "dword", BitOR($DIGCF_PRESENT, $DIGCF_DEVICEINTERFACE))
    $hDevInfo = $hDevInfo[0]
    If $hDevInfo == $INVALID_HANDLE_VALUE Then Return 0
    
; Retrieve a context structure for a device interface
; of a device information set.
    $dwIndex = 0
    $bRet = False

    $buf = DllStructCreate($SP_DEV_BUF)
    $pspdidd = DllStructCreate($SP_DEVICE_INTERFACE_DETAIL_DATA, DllStructGetPtr($buf))
    $spdid = DllStructCreate($SP_DEVICE_INTERFACE_DATA)
    $spdd = DllStructCreate($SP_DEVINFO_DATA)
    
    DllStructSetData($spdid, "cbSize", DllStructGetSize($spdid))

    While True
        $bRet = DllCall("setupapi.dll", "int", "SetupDiEnumDeviceInterfaces", "ptr", $hDevInfo, "ptr", $NULL, _
                        "ptr", $GUID, "dword", $dwIndex, "ptr", DllStructGetPtr($spdid))
        If Not $bRet[0] Then ExitLoop

        $res = DllCall("setupapi.dll", "int", "SetupDiGetDeviceInterfaceDetail", "ptr", $hDevInfo, "ptr", DllStructGetPtr($spdid), _
                        "ptr", $NULL, "dword", 0, "dword*", "", "ptr", $NULL)
        $dwSize = $res[5]
        
        If $dwSize <> 0 And $dwSize <= DllStructGetSize($buf) Then
            DllStructSetData($pspdidd, "cbSize", 5); sizeof dword + char = 5 bytes
            _ZeroMemory(DllStructGetPtr($spdd), DllStructGetSize($spdd))
            DllStructSetData($spdd, "cbSize", DllStructGetSize($spdd))

            $res = DllCall("setupapi.dll", "int", "SetupDiGetDeviceInterfaceDetail", "ptr", $hDevInfo, "ptr", DllStructGetPtr($spdid), _
                            "ptr", DllStructGetPtr($pspdidd), "dword", $dwSize, "dword*", "", "ptr", DllStructGetPtr($spdd))
                            
            If $res[0] Then
                
                $hDrive = DllCall("kernel32.dll", "ptr", "CreateFile", "str", DllStructGetData($pspdidd, "DevicePath"), "dword", 0, _
                                    "dword", BitOR($FS_READ, $FS_WRITE), "ptr", $NULL, "dword", $O_EXISTS, _
                                    "dword", 0, "ptr", $NULL)
                $hDrive = $hDrive[0]
                          
                If $hDrive <> $INVALID_HANDLE_VALUE Then
                    $sdn2 = DllStructCreate($STORAGE_DEVICE_NUMBER)
                    $res = DllCall("kernel32.dll", "int", "DeviceIoControl", "ptr", $hDrive, "dword", $IOCTL_STORAGE_GET_DEVICE_NUMBER, _
                            "ptr", $NULL, "dword", 0, "ptr", DllStructGetPtr($sdn2), "dword", DllStructGetSize($sdn2), _
                            "dword*", "", "ptr", $NULL)
                    
                    If $res[0] Then
                        If $DeviceNumber == DllStructGetData($sdn2, "DeviceNumber") Then
                            $res = DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hDrive)
                            $res = DllCall("setupapi.dll", "int", "SetupDiDestroyDeviceInfoList", "ptr", $hDevInfo)
                            Return DllStructGetData($spdd, "DevInst")
                        EndIf
                    EndIf
                    
                    $res = DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hDrive)
                EndIf
            EndIf
        EndIf
        $dwIndex += 1
    WEnd

    $res = DllCall("setupapi.dll", "int", "SetupDiDestroyDeviceInfoList", "ptr", $hDevInfo)

    Return 0
EndFunc

Func _DevInstEject($DevInst)
    $bSuccess = False

; get drives's parent, e.g. the USB bridge,
; the SATA port, an IDE channel with two drives, etc.
    $res = DllCall("setupapi.dll", "dword", "CM_Get_Parent", "dword*", "", "dword", $DevInst, "ulong", 0)
    If Not $res[0] == $CR_SUCCESS Then Return 1
    $DevInstParent = $res[1]
    
    $res = DllCall("setupapi.dll", "dword", "CM_Get_Device_IDW", "ptr", $DevInstParent, "wstr", "", "ulong", 1024, "ulong", 0)
    
    $res = DllCall("setupapi.dll", "dword", "CM_Get_DevNode_Status", "ulong*", "", "ulong*", "", "ptr", $DevInstParent, "ulong", 0)
    $IsRemovable = (BitAND($res[1], $DN_REMOVABLE) <> 0)

    For $tries = 1 To 3
; sometimes we need some tries...
        $res = DllCall("setupapi.dll", "dword", "CM_Query_And_Remove_SubTreeW", "dword", $DevInstParent, _
                        "dword*", "", "wstr", "", "ulong", 260, "ulong", $CM_REMOVE_NO_RESTART)
        If $res[0] == $CR_ACCESS_DENIED Then
            $res = DllCall("setupapi.dll", "dword", "CM_Request_Device_EjectW", "dword", $DevInstParent, _
                            "dword*", "", "wstr", "", "ulong", 260, "ulong", 0)
        EndIf

        $bSuccess = (($res[0] == $CR_SUCCESS) And ($res[2] == $PNP_VetoTypeUnknown))
        If $bSuccess Then ExitLoop

        Sleep(500); required to give the next tries a chance
    Next
    
    Return $bSuccess
EndFunc

Func _ZeroMemory($ptr, $size)
    $struct = DllStructCreate("byte[" & $size & "]", $ptr); create a byte struct at ptr of memory to zero
    $szdata = "0x"
    For $i = 1 To $size; create $size byte string of binary 0's
        $szdata &= "00"
    Next
    DllStructSetData($struct, 1, Binary($szdata)); zero the memory
EndFunc